#!/usr/bin/env python
"""
###############################################################################
# FILE NAME : add_mac2name.py
# AUTHOR : J.Enochs
# CREATION DATE : 07-Sep-2016
# LAST MODIFIED : 29-Oct-2016
# DESCRIPTION : Adds a name / mac to the inital quiz scores.db
#
###############################################################################/
"""

import os
import shelve
from uuid import getnode as get_mac

MAC2NAME = {}
SERVERMAC = 0

def main():
    os.system("clear")
    try:
        load_core_data()
        add_me()
        save_data()
        print MAC2NAME
    except (KeyboardInterrupt, SystemExit):
        pass

def load_core_data():
    global MAC2NAME
    global SERVERMAC
    
    # Get the student to MAC dictionary
    try:
        db = shelve.open("../Ex1_2_init_quiz_svr/initial_quiz_scores.db")
        if "macDict" in db:
            MAC2NAME = db["macDict"]
        else:
            print "\nMAC DATA FAILED TO LOAD\n"
    except Exception as e:
        print e
        print "\nMAC DATA FAILED TO LOAD\n"
        exit(0)
    finally:
        db.close()

    try:
        SERVERMAC = get_mac()
    except:
        print "\nFAILED TO READ SERVER MAC ADDRESS!\n"
        exit(0)

def add_me():
    if SERVERMAC > 0:
        MAC2NAME[SERVERMAC] = "Jason"
    if 0 in MAC2NAME:
        del MAC2NAME[0]

def save_data():
    try:
        db = shelve.open("../Ex1_2_init_quiz_svr/initial_quiz_scores.db")
        if "macDict" in db:
            db["macDict"] = MAC2NAME
        else:
            print "\nMAC DATA FAILED TO SAVE\n"
    except Exception as e:
        print e
        print "\nMAC DATA FAILED TO SAVE\n"
        exit(0)
    finally:
        db.close()

    
    




if __name__ == "__main__":
    main()
