#!/usr/bin/env python
"""
###############################################################################
# FILE NAME : calculate_scores.py
# AUTHOR : J.Enochs
# CREATION DATE : 19-Sep-2016
# LAST MODIFIED : 19-Sep-2016
# DESCRIPTION : calculates the students scores from captured flags.
#
###############################################################################/
"""

import shelve
import os

FLAGS_DICT = {}
flag_key_list = []
key_display_index_dict = {}



def get_class_flags():
    try:
        db = shelve.open("class_flag_record.db")
        CLASS_FLAGS = db["classFlags"]
        if not CLASS_FLAGS:
            raise ValueError("No CLASS_FLAGS data!")
    except ValueError as e:
        print e
        raw_input("\nPress any key to continues...")
        exit(0)
    finally:
        db.close()
    print CLASS_FLAGS
    return

def get_port_scanner_flags():
    try:
        db = shelve.open("ex1_flags.db")
        MAC2NAME = db["macDict"]
        if not MAC2NAME:
            raise ValueError("No Port Scan falgs!")
    except ValueError as e:
        print e
        raw_input("\nPress any key to continues...")
        exit(0)
    finally:
        db.close()
    print MAC2NAME
    return

def main():
    global CLASS_FLAGS
    global key_display_index_dict
    global flag_key_list
    get_class_flags()
    get_port_scanner_flags()
    exit()

    flag_key_list = list(FLAGS_DICT)
    os.system("clear")
    while True:
        print "\nMake a selection:\n\n\
            A - Show flag list\n\
            B - Add flag\n\
            C - Delete flag\n\
            D - Save & Exit\n\
            E - Save Only\n"
        ans = raw_input("Selection: ")
        ans = ans.lower()
    
        if ans == 'a':
            print_list(flag_key_list, key_display_index_dict) 
        elif ans == 'b':
            new_flag = raw_input("Enter new flag: ")
            exer = raw_input("Enter exercise: ")
            FLAGS_DICT[new_flag] = exer
            flag_key_list = list(FLAGS_DICT)
            save_only()
            print_list(flag_key_list, key_display_index_dict)
        elif ans == 'c':
            key_display_index_dict = {}
            ans = 0
            while True:
                os.system("clear")
                count = 0
                print "\n****** FLAGS ******\n"
                for key in flag_key_list:
                    count = count + 1
                    print "   {} - {}  {}".format(count, FLAGS_DICT[key], key)
                    key_display_index_dict[count] = key
                print "\n*******************\n"
                ans = raw_input("\nSelect flag to delete: ")
                try:
                    ans = int(ans)
                    if int(ans) in key_display_index_dict: 
                        break
                    else:
                        print "\nThat's not a valid selection, try again!"
                        raw_input("Press 'enter' to continue...")
                except:
                    print "\nThat's not a valid selection, try again!"
                    raw_input("Press 'enter' to continue...")
            count = 0
            key_to_del = None
            for key in flag_key_list:
                count = count + 1
                if count == ans:
                    key_to_del = key
            del FLAGS_DICT[key_to_del]
            del key_display_index_dict[ans] 
            flag_key_list.remove(key_to_del)
            save_only()
            print_list(flag_key_list, key_display_index_dict)
            
            print "\n\n   <<<<< FLAG DELETED >>>>>\n\n"
        elif ans == 'd':
            save_only()
            and_exit()
        elif ans == 'e':
            save_only()
            os.system("clear")
            print "\n\n\n       FLAGS SAVED ! \n\n"
        else:
            print "Invalid selection, try again."
            raw_input("Press 'enter' to continue...")
            os.system("clear")

def save_only():
    global FLAGS_DICT
    global key_display_index_dict
    global flag_key_list
    try:
        db  = shelve.open("flags.db")
        db["flagsDict"] = FLAGS_DICT
    except:
        print "\nFAILED TO OPEN DB ON WRITE\n"
    finally:
        db.close()

def and_exit():
    global FLAGS_DICT
    global key_display_index_dict
    global flag_key_list
    exit(0)
        
def print_list(flag_key_list, key_display_index_dict):
    os.system("clear")
    count = 0
    print "\n****** FLAGS ******\n"
    for key in flag_key_list:
        count = count + 1
        print "   {} - {}  {}".format(count, FLAGS_DICT[key], key)
        key_display_index_dict[count] = key
    print "\n*******************\n"
    raw_input("\n\nPress any key to continue...")
    os.system("clear")
    return count, key_display_index_dict


if __name__ == "__main__":
    main()
