#!/usr/bin/env python
"""
###############################################################################
# FILE NAME : clear_quiz_data.py
# AUTHOR : J.Enochs
# CREATION DATE : 25-Sep-2016
# LAST MODIFIED : 11-Oct-2016
# DESCRIPTION : Clears all quiz data in the current database
#
###############################################################################/
"""

import shelve
import os

def main():
    qry = raw_input("\n\n   You're about to delete all CTF scores.  Press 'z' to continue.  All other keys exit.\n")

    qry = qry.lower()
    if qry != 'z':
        exit(0)
    try:
        db = shelve.open("../class_flag_scores.db")
        if "mac2scores" in db:
            db["mac2scores"] = {}
    except Exception as e:
        print e
        exit(0)
    finally:
        db.close()
    os.system("clear")
    print "\n\n   CTF SCORES DELETED\n\n"
    return




if __name__ == "__main__":
    main()
